var ManageTeamsDialogs = function() {
    
    function initAddTeamDialog() {
        getGlobalSettingsAndViewDialog(addTeamDialog);
    }

    function addTeamDialog(globalSettingAllowUsersViewStatistics, globalSettingAllowHrChangeViewStatistics) {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.addTeamDialog({
            allowHrChangeViewStatistics: globalSettingAllowHrChangeViewStatistics,
            allowUsersViewStatistics: globalSettingAllowUsersViewStatistics
        }));

        AJS.$('[name=newTeamButton]').click(function() {
            dialog.show();
        });
    }

    function initDeleteTeamDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.deleteTeamDialog());

        AJS.$("[name=deleteTeamButton]").click(function() {
            var teamId = AJS.$(this).attr("team-id");
            var teamName = AJS.$(this).attr("team-name");
            dialog.getElementByName("description").html(AJS.I18n.getText('vacationmanager.action.manage.teams.delete.confirmation.text', teamName));
            dialog.getElementByName("teamId").val(teamId);
            dialog.show();
        });

    }
    
    function initEditTeamNameDialog() {
        getGlobalSettingsAndViewDialog(editTeamNameDialog);
    }

    function getGlobalSettingsAndViewDialog(func){
        VM$.configuration.getAllowHrChangeViewStatistics(function (gr) {
            getGlobalSettingAllowUsersViewStatistics(gr, func);
        });
    }

    function getGlobalSettingAllowUsersViewStatistics(globalSettingAllowHrChangeViewStatistics, func) {
        VM$.configuration.getAllowUsersToViewStatistics(function (globalSettingAllowUsersViewStatistics) {
            func(globalSettingAllowUsersViewStatistics, globalSettingAllowHrChangeViewStatistics);
        });
    }

    function editTeamNameDialog(globalSettingAllowUsersViewStatistics, globalSettingAllowHrChangeViewStatistics) {
        var allowUsersViewStatistics = AJS.$('[name=editTeamNameButton]').attr('team-allowUsersViewStatisticsValue') === 'true';
        if(!globalSettingAllowHrChangeViewStatistics) {
            allowUsersViewStatistics = globalSettingAllowUsersViewStatistics;
        }

        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.editTeamNameDialog({
            teamIdValue: AJS.$('[name=editTeamNameButton]').attr('team-id'),
            teamName: AJS.$('[name=editTeamNameButton]').attr('team-name'),
            teamDescription: AJS.$('[name=editTeamNameButton]').attr('team-description'),
            allowHrChangeViewStatistics: globalSettingAllowHrChangeViewStatistics,
            allowUsersViewStatistics: allowUsersViewStatistics
        }));

        AJS.$('[name=editTeamNameButton]').click(function () {
            dialog.show();
        });
    }

    return {        
        initAddTeamDialog:initAddTeamDialog,
        initDeleteTeamDialog:initDeleteTeamDialog,
        initEditTeamNameDialog:initEditTeamNameDialog
    };
}();
