var HolidaySchemeDialogs = function() {

    function initAddNewHolidaySchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Holidays.HolidaySchemeDialogs.addNewHolidaySchemeDialog());

        AJS.$("[name=addNewHolidaySchemeButton]").click(function() {
            dialog.getElementByName("newHolidaySchemeName").val("");
            dialog.show();
        });
    }

    function initCopyHolidaySchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Holidays.HolidaySchemeDialogs.copyHolidaySchemeDialog());

        AJS.$("[name=copyHolidaySchemeButton]").click(function() {
            var schemeId = AJS.$(this).attr("scheme-id");
            var schemeName = _.escape(AJS.$(this).attr("scheme-name"));
            dialog.getElementByName("copyHolidaySchemeSourceName").text(schemeName);
            dialog.getElementByName("copyHolidaySchemeDestName").val(AJS.I18n.getText("vacationmanager.action.manage.holiday.schemes.copy.calendar.dest.name.copy.of", schemeName));
            dialog.getElementByName("copyHolidaySchemeSourceId").val(schemeId);
            dialog.show();
        });
    }

    function initDeleteHolidaySchemeDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Holidays.HolidaySchemeDialogs.deleteHolidaySchemeDialog());

        AJS.$("[name=deleteHolidaySchemeButton]").click(function() {
            var schemeId = AJS.$(this).attr("scheme-id");
            var schemeName = _.escape(AJS.$(this).attr("scheme-name"));
            dialog.getElementByName("deleteHolidaySchemeText").html(AJS.I18n.getText('vacationmanager.action.manage.holiday.schemes.delete.confirmation.text', schemeName));
            dialog.getElementByName("deleteHolidaySchemeId").val(schemeId);
            dialog.show();
        });
    }
    
    function initEditHolidaySchemeNameDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Workdays.Holidays.HolidaySchemeDialogs.editHolidaySchemeNameDialog());

        AJS.$("[name=editHolidaySchemeNameButton]").click(function() {
            dialog.getElementByName("newHolidaySchemeName").val(AJS.$(this).attr("scheme-name"));
            dialog.getElementByName("newHolidaySchemeId").val(AJS.$(this).attr("scheme-id"));
            dialog.show();
        });
    }

    return {        
        initAddNewHolidaySchemeDialog:initAddNewHolidaySchemeDialog,
        initCopyHolidaySchemeDialog:initCopyHolidaySchemeDialog,
        initDeleteHolidaySchemeDialog:initDeleteHolidaySchemeDialog,
        initEditHolidaySchemeNameDialog:initEditHolidaySchemeNameDialog
    }
}();
