function HiddenSummaryField(container) {
    var isAutoSummaryEnabled = container.find('[name=vmAutoSummary]').val() === 'true';
    var summaryField = container.find('input#summary');
    var defaultSummary = AJS.I18n.getText('vacationmanager.create.issue.default.summary');

    function hideSummaryFieldIfNeeded() {
        if (isAutoSummaryEnabled) {
            hideSummaryField();
            setDefaultSummaryValueIfEmpty();
        }
    }

    function hideSummaryField() {
        summaryField.parent().hide();
    }

    function setDefaultSummaryValueIfEmpty() {
        if (!summaryField.val()) {
            summaryField.val(defaultSummary);
        }
    }

    hideSummaryFieldIfNeeded();
}
