(function () {
    getPeriodTypeCustomFieldId(openEditDialogonInlineEdit);
    getEndTimeMinutesCustomFieldId(openEditDialogonInlineEdit);
    getHalfOfDayCustomFieldId(openEditDialogonInlineEdit);

    function getPeriodTypeCustomFieldId(callback) {
        VM$.configuration.getFields(function (fieldsIds) {
            if (fieldsIds && fieldsIds.hasOwnProperty('PERIOD_TYPE')) {
                callback(fieldsIds['PERIOD_TYPE']);
            }
        })
    }

    function getEndTimeMinutesCustomFieldId(callback) {
        VM$.configuration.getFields(function (fieldsIds) {
            if (fieldsIds && fieldsIds.hasOwnProperty('END_TIME_MINUTES')) {
                callback(fieldsIds['END_TIME_MINUTES']);
            }
        })
    }

    function getHalfOfDayCustomFieldId(callback) {
        VM$.configuration.getFields(function (fieldsIds) {
            if (fieldsIds && fieldsIds.hasOwnProperty('HALF_DAY')) {
                callback(fieldsIds['HALF_DAY']);
            }
        })
    }

    // https://community.atlassian.com/t5/Answers-Developer-Questions/jira-5-1-inline-editing-how-this-will-work-for-you/qaq-p/491625#M29342
    function openEditDialogonInlineEdit(customFieldId) {
        if (typeof JIRA.Issues === undefined) {
            return;
        }

        JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function () {
            doOpenEditDialogonInlineEdit(customFieldId);
        });
        doOpenEditDialogonInlineEdit(customFieldId);
    }

    function doOpenEditDialogonInlineEdit(customFieldId) {
        var view = AJS.$('#customfield_' + customFieldId + '-val');

        view.click(function (event) {
            AJS.$('#edit-issue').click();
            event.stopPropagation();
            event.preventDefault();
        });
    }
    
})();