function modifyIssueTypeLabel() {

    var createVacationDocumentLabel = AJS.I18n.getText('vacationmanager.create.issue.new.document');
    var issueTypeLabel = AJS.I18n.getText('vacationmanager.create.issue.issue.type');

    // popup window
    AJS.$('label[for="issuetype"]').each(function() {
        var obj = AJS.$(this);
        if (obj.closest('form').find('div[name="vm_chart"]').length > 0) {
            obj.html(issueTypeLabel + '<span class="aui-icon icon-required">Required</span>');
            AJS.$(this).closest('div#create-issue-dialog').find('h2').html(createVacationDocumentLabel);
        }
    });

    // dedicated create-issue page
    AJS.$('label[for="issue-create-issue-type"]').each(function() {
        var obj = AJS.$(this);
        if (obj.closest('form').find('div[name="vm_chart"]').length > 0) {
            obj.html(issueTypeLabel);
            obj.closest('section#content').find('h1').html(createVacationDocumentLabel);
        }
    });

    if (window.location.search.indexOf('createVacationDocument=true') >= 0) {
        AJS.$('label[for="issuetype"]').html(issueTypeLabel + '<span class="aui-icon icon-required">Required</span>');
        AJS.$('.aui-page-header-main').children().html(createVacationDocumentLabel);
        AJS.$('input#project-field').prop('disabled', true);
        AJS.$('#project-single-select').find('.drop-menu').css('pointer-events', 'none');
    }
}

AJS.$(document).ready(function() {
    modifyIssueTypeLabel();
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
        modifyIssueTypeLabel();
    });
});

var datatablesLangObject = {
    'decimal' : AJS.I18n.getText('vacationmanager.datatables.decimal'),
    'emptyTable' : AJS.I18n.getText('vacationmanager.datatables.emptyTable'),
    'info' : AJS.I18n.getText('vacationmanager.datatables.info'),
    'infoEmpty' : AJS.I18n.getText('vacationmanager.datatables.infoEmpty'),
    'infoFiltered' : AJS.I18n.getText('vacationmanager.datatables.infoFiltered'),
    'infoPostFix' : AJS.I18n.getText('vacationmanager.datatables.infoPostFix'),
    'thousands' : AJS.I18n.getText('vacationmanager.datatables.thousands'),
    'lengthMenu' : AJS.I18n.getText('vacationmanager.datatables.lengthMenu'),
    'loadingRecords' : AJS.I18n.getText('vacationmanager.datatables.loadingRecords'),
    'processing' : AJS.I18n.getText('vacationmanager.datatables.processing'),
    'search' : AJS.I18n.getText('vacationmanager.datatables.search'),
    'searchPlaceholder' : AJS.I18n.getText('vacationmanager.datatables.searchPlaceholder'),
    'zeroRecords' : AJS.I18n.getText('vacationmanager.datatables.zeroRecords'),
    'paginate' : {
        'first' : AJS.I18n.getText('vacationmanager.datatables.paginate.first'),
        'last' : AJS.I18n.getText('vacationmanager.datatables.paginate.last'),
        'next' : AJS.I18n.getText('vacationmanager.datatables.paginate.next'),
        'previous' : AJS.I18n.getText('vacationmanager.datatables.paginate.previous')
    },
    'aria' : {
        'sortAscending' : AJS.I18n.getText('vacationmanager.datatables.aria.sortAscending'),
        'sortDescending' : AJS.I18n.getText('vacationmanager.datatables.aria.sortDescending')
    }
};

VM$.formatDate = function(date) {
    var dateFormat = AJS.Meta.get('date-dmy');
    if (dateFormat != null) {
        dateFormat = dateFormat.toUpperCase();
    } else {
        dateFormat = 'YYYY-MM-DD';
    }
    return moment(date).format(dateFormat);
}

VM$.formatDateIso = function(date){
    return moment(date).format('YYYY-MM-DD');
}

function pad(num, size) {
    var s = num + '';
    while (s.length < size)
        s = '0' + s;
    return s;
}

VM$.openUserPickerWindow = function(element) {
    var vWinUsers = window.open(AJS.params.baseURL+'/secure/popups/UserPickerBrowser.jspa?formName=jiraform&multiSelect=true&element=' + element,
    		'UserPicker', 'status=yes,resizable=yes,top=100,left=200,width=580,height=750,scrollbars=yes');
    vWinUsers.opener = self;
    vWinUsers.focus();
}

VM$.openGroupPickerWindow = function(element) {
    var vWinUsers = window.open(AJS.params.baseURL+'/secure/popups/GroupPickerBrowser.jspa?formName=jiraform&multiSelect=true&element=' + element,
    		'GroupPicker', 'status=yes,resizable=yes,top=100,left=200,width=580,height=750,scrollbars=yes');
    vWinUsers.opener = self;
    vWinUsers.focus();
}

var VM = VM$;

new IssueScreenListener().listenForNewIssueDialog([
	HiddenSummaryField,
	VacationManagerChart,
	PeriodTypeFields,
    VacationManagerHourlyLeaveFields,
    MinutesPickerField
]);
